> ## Documentation Index
> Fetch the complete documentation index at: https://razorpay-60c89f9a-mintlify-audit-missing-sections-1778528421.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# 1. Create the Authorisation Transaction

> The flow to complete an authorisation transaction using paper NACH differs from the other payment method's flow.

<Steps>
  <Step title="Create a customer.">
    Create a customer.
  </Step>

  <Step title="Create an order by passing the `customer_id` and the method as `nac...">
    Create an order by passing the `customer_id` and the method as `nach`. Razorpay generates a NACH form with the customer information pre-filled and ready to sign.
  </Step>

  <Step title="The customer can get the form in one of the following ways to sign it:">
    The customer can get the form in one of the following ways to sign it:

    * You can download the form from the Dashboard and send it to the customer.
    * A customer can download the form from the Hosted page (in the case of registration links).
  </Step>

  <Step title="The signed form can be uploaded in one of the following ways:">
    The signed form can be uploaded in one of the following ways:

    * Using the Standard Checkout page.
    * Hosted page (in the case of registration links).
    * The customer can send you the form and you can upload the form for the customer. The acceptable image formats and size are:
    * jpeg
    * jpg
    * png
    * Maximum accepted size is 6 MB.
  </Step>
</Steps>

Once the details are validated, the authorisation transaction is completed and a token is generated. You can charge your customer as per your business model after the token status changes to `confirmed`.

You can create an authorisation transaction:

* Using the [Razorpay Standard Checkout](#11-using-razorpay-standard-checkout).
* Using a [Registration Link](#12-using-a-registration-link).

## 1.1. Using Razorpay Standard Checkout

To create an authorisation transaction using the Razorpay Standard Checkout, you need to:

<Steps>
  <Step title="[Create a Customer](#111-create-a-customer).">
    [Create a Customer](#111-create-a-customer).
  </Step>

  <Step title="[Create an Order](#112-create-an-order).">
    [Create an Order](#112-create-an-order).
  </Step>

  <Step title="[Create Authorisation Payment using Razorpay Standard Checkout](#11...">
    [Create Authorisation Payment using Razorpay Standard Checkout](#113-create-an-authorisation-payment).
  </Step>
</Steps>

### 1.1.1. Create a Customer

Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API.

You can create [customers](/api/customers) with basic information such as `email` and `contact` and use them for various Razorpay offerings. The following endpoint creates a customer.

/customers

### Sample Code

````cURL: Curl theme={null}
curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
-X POST https://api.razorpay.com/v1/customers \
-H "Content-Type: application/json" \
-d '{
  "name": "Gaurav Kumar",
  "email": "gaurav.kumar@example.com",
  "contact": "+919876543210",
  "fail_existing": "0",
  "notes":{
    "note_key_1": "September",
    "note_key_2": "Make it so."
  }
}'

```java: Java
RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

JSONObject customerRequest = new JSONObject();
customerRequest.put("name","Gaurav Kumar");
customerRequest.put("contact","+919876543210");
customerRequest.put("email","gaurav.kumar@example.com");
customerRequest.put("fail_existing", "0");
JSONObject notes = new JSONObject();
notes.put("notes_key_1","Tea, Earl Grey, Hot");
notes.put("notes_key_2","Tea, Earl Grey… decaf.");
customerRequest.put("notes",notes);

Customer customer = razorpay.customers.create(customerRequest);

```python: Python
import razorpay
client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

client.customer.create({
    'name': 'Gaurav Kumar',
    'email': 'gaurav.kumar@example.com',
    'contact': '+919876543210',
    'fail_existing': "0",
    'notes': {'note_key_1': 'September', 'note_key_2': 'Make it so.'}
    })

```go: Go
import ( razorpay "github.com/razorpay/razorpay-go" )
client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

data := map[string]interface{}{
    "name": "Gaurav Kumar",
    "contact": +919876543210,
    "email": "gaurav.kumar@example.com",
    "fail_existing": "0",
    "notes": map[string]interface{}{
        "notes_key_1": "Tea, Earl Grey, Hot",
        "notes_key_2": "Tea, Earl Grey… decaf.",
    },
}
body, err := client.Customer.Create(data, nil)

```php: PHP
$api = new Api($key_id, $secret);

$api->customer->create(array('name' => 'Gaurav Kumar', 'email' => 'gaurav.kumar@example.com','contact'=>'+919876543210','fail_existing' => "0", 'notes'=> array('notes_key_1'=> 'Tea, Earl Grey, Hot','notes_key_2'=> 'Tea, Earl Grey… decaf'));
```csharp: .NET
RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

Dictionary options = new Dictionary();

options.Add("name", "Gaurav Kumar"); 
options.Add("contact", "+919876543210"); 
options.Add("email", "gaurav.kumar@example.com"); 
options.Add("fail_existing", "0"); 

Customer customer = Customer.Create(options);

```ruby: Ruby
require "razorpay"
Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

para_attr = {
  "name": "Gaurav Kumar",
  "contact": "+919876543210",
  "email": "gaurav.kumar@example.com",
  "fail_existing": "0",
  "notes": {
    "notes_key_1": "Tea, Earl Grey, Hot",
    "notes_key_2": "Tea, Earl Grey… decaf."
  }
}

Razorpay::Customer.create(para_attr)

```javascript: Node.js
var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

instance.customers.create({
  name: "Gaurav Kumar",
  contact: "+919876543210",
  email: "gaurav.kumar@example.com",
  fail_existing: "0",
  notes: {
    notes_key_1: "Tea, Earl Grey, Hot",
    notes_key_2: "Tea, Earl Grey… decaf."
  }
})
````

```json: Response theme={null}
{
  "id":"cust_1Aa00000000001",
  "entity":"customer",
  "name":"Gaurav Kumar",
  "email":"gaurav.kumar@example.com",
  "contact":"+919876543210",
  "gstin":null,
  "notes":{
      "note_key_1":"September",
      "note_key_2":"Make it so."
  },
  "created_at ":1234567890
}
```

#### Request Parameters

`name`
: `string` The name of the customer. For example, `Gaurav Kumar`.

`email`
: `string` The email address of the customer. For example, `gaurav.kumar@example.com`.

`contact`
: `string` The phone number of the customer. For example, `9876543210`.

`fail_existing` *optional*
: `string` The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter `fail_existing` to get the existing customer's details in the response. Possible values:

* `1` (default): If a customer with the same details already exists, throws an error.
* `0`: If a customer with the same details already exists, fetches details of the existing customer.

`notes` *optional*
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

#### Response Parameters

`id`
: `string` The unique identifier of the customer. For example `cust_1Aa00000000001`.

`entity`
: `string` The name of the entity. Here, it is `customer`.

`name`
: `string` The name of the customer. For example, `Gaurav Kumar`.

`email`
: `string` The email address of the customer. For example, `gaurav.kumar@example.com`.

`contact`
: `string` The phone number of the customer. For example, `9876543210`.

`notes`
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`created_at`
: `integer` A Unix timestamp, at which the customer was created.

You can create an order once you create a customer for the payment authorisation.

### 1.1.2. Create an Order

Use the [Orders API](/api/orders) to create a unique Razorpay `order_id` that is associated with the authorisation transaction. The following endpoint creates an order.

/orders

````cURL: Curl theme={null}
curl -u : \
-X POST https://api.razorpay.com/v1/orders \
-H "Content-Type: application/json" \
-d '{
  "amount":0,
  "currency":"INR",
  "method":"nach",
  "customer_id": "cust_1Aa00000000001",
  "receipt":"Receipt No. 1",
  "notes": {
    "notes_key_1": "Beam me up Scotty",
    "notes_key_2": "Engage"
  },
  "token":{
    "auth_type":"physical",
    "max_amount":10000000,
    "expire_at":2709971120,
    "notes": {
      "notes_key_1": "Tea, Earl Grey, Hot",
      "notes_key_2": "Tea, Earl Grey… decaf."
    },
    "bank_account":{
      "account_number":"11214311215411",
      "ifsc_code":"HDFC0000001",
      "beneficiary_name":"Gaurav Kumar",
      "account_type":"savings"
    },
    "nach":{
      "form_reference1":"Recurring Payment for Gaurav Kumar",
      "form_reference2":"Method Paper NACH",
      "description":"Paper NACH Gaurav Kumar"
    }
  }
}'

```java: Java
RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

JSONObject orderRequest = new JSONObject();
orderRequest.put("amount", 0);
orderRequest.put("currency", "INR");
orderRequest.put("customer_id", "cust_JDdNazagOgg9Ig");
orderRequest.put("method", "nach");
orderRequest.put("receipt", "receipt#1");
JSONObject notes = new JSONObject();
notes.put("notes_key_1","Tea, Earl Grey, Hot");
notes.put("notes_key_2","Tea, Earl Grey… decaf.");
orderRequest.put("notes", notes);
JSONObject token = new JSONObject();
token.put("auth_type","physical");
token.put("max_amount","10000000");
token.put("expire_at","2709971120");
JSONObject tokenNotes = new JSONObject();
tokenNotes.put("notes_key_1","Tea, Earl Grey, Hot");
tokenNotes.put("notes_key_2","Tea, Earl Grey… decaf.");
token.put("notes",tokenNotes);
orderRequest.put("token", token);
JSONObject bankAccount = new JSONObject();
bankAccount.put("beneficiary_name","Gaurav Kumar");
bankAccount.put("account_number","11214311215411");
bankAccount.put("account_type","savings");
bankAccount.put("ifsc_code","HDFC0001233");
token.put("bank_account",bankAccount);
JSONObject nach = new JSONObject();
nach.put("form_reference1","Recurring Payment for Gaurav Kumar");
nach.put("form_reference2","Method Paper NACH");
nach.put("description","Paper NACH Gaurav Kumar");
token.put("nach",nach);

Order order = razorpay.orders.create(orderRequest);

```php: PHP
$api = new Api($key_id, $secret);

$api->order->create(array('amount' => 0,'currency' => 'INR','method' => 'nach','customer_id' => 'cust_1Aa00000000001','receipt' => 'Receipt No. 1',  'notes' => array('notes_key_1' => 'Beam me up Scotty','notes_key_2' => 'Engage'),'token' => array('auth_type' => 'physical','max_amount' => 10000000,'expire_at' => 2709971120,'notes' => array('notes_key_1' => 'Tea, Earl Grey, Hot','notes_key_2' => 'Tea, Earl Grey… decaf.'),'bank_account' => array('account_number' => '11214311215411','ifsc_code' => 'HDFC0000001','beneficiary_name' => 'Gaurav Kumar','account_type' => 'savings'),'nach' => array('form_reference1' => 'Recurring Payment for Gaurav Kumar','form_reference2' => 'Method Paper NACH','description' => 'Paper NACH Gaurav Kumar'))));

```javascript: Node.js
var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

instance.orders.create({
  amount: 0,
  currency: "INR",
  method: "nach",
  customer_id: "cust_1Aa00000000001",
  receipt: "Receipt No. 1",
  notes: {
    notes_key_1: "Beam me up Scotty",
    notes_key_2: "Engage"
  },
  token: {
    auth_type: "netbanking",
    max_amount: 9999900,
    expire_at: 4102444799,
    notes: {
      notes_key_1: "Tea, Earl Grey, Hot",
      notes_key_2: "Tea, Earl Grey… decaf."
    },
    bank_account: {
      beneficiary_name: "Gaurav Kumar",
      account_number: "1121431121541121",
      account_type: "savings",
      ifsc_code: "HDFC0000001"
    }
  }
})

```python: Python
client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

client.order.create({
    'amount': 0,
    'currency': 'INR',
    'method': 'nach',
    'customer_id': 'cust_1Aa00000000001',
    'receipt': 'Receipt No. 1',
    'notes': {'notes_key_1': 'Beam me up Scotty',
              'notes_key_2': 'Engage'},
    'token': {
        'auth_type': 'netbanking',
        'max_amount': 9999900,
        'expire_at': 4102444799,
        'notes': {'notes_key_1': 'Tea, Earl Grey, Hot',
                  'notes_key_2': 'Tea, Earl Grey... decaf.'},
        'bank_account': {
            'beneficiary_name': 'Gaurav Kumar',
            'account_number': 1121431121541121,
            'account_type': 'savings',
            'ifsc_code': 'HDFC0000001'
            }
        }
    })

```ruby: Ruby
require "razorpay"
Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

para_attr = {
  "amount": 0,
  "currency": "INR",
  "method": "nach",
  "customer_id": "cust_1Aa00000000001",
  "receipt": "Receipt No. 1",
  "notes": {
    "notes_key_1": "Beam me up Scotty",
    "notes_key_2": "Engage"
  },
  "token": {
    "auth_type": "netbanking",
    "max_amount": 9999900,
    "expire_at": 4102444799,
    "notes": {
      "notes_key_1": "Tea, Earl Grey, Hot",
      "notes_key_2": "Tea, Earl Grey… decaf."
    },
    "bank_account": {
      "beneficiary_name": "Gaurav Kumar",
      "account_number": 1121431121541121,
      "account_type": "savings",
      "ifsc_code": "HDFC0000001"
    }
  }
}

Razorpay::Order.create(para_attr)

```go: Go
import ( razorpay "github.com/razorpay/razorpay-go" )
client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

data := map[string]interface{}{
  "amount":0,
  "currency":"INR",
  "method":"nach",
  "customer_id": "cust_1Aa00000000001",
  "receipt":"Receipt No. 1",
  "notes": map[string]interface{}{
    "notes_key_1": "Beam me up Scotty",
    "notes_key_2": "Engage",
  },
  "token":map[string]interface{}{
    "auth_type":"physical",
    "max_amount":10000000,
    "expire_at":2709971120,
    "notes": map[string]interface{}{
      "notes_key_1": "Tea, Earl Grey, Hot",
      "notes_key_2": "Tea, Earl Grey… decaf.",
    },
    "bank_account":map[string]interface{}{
      "account_number":"11214311215411",
      "ifsc_code":"HDFC0000001",
      "beneficiary_name":"Gaurav Kumar",
      "account_type":"savings",
    },
    "nach":map[string]interface{}{
      "form_reference1":"Recurring Payment for Gaurav Kumar",
      "form_reference2":"Method Paper NACH",
      "description":"Paper NACH Gaurav Kumar",
    },
  },
}
body, err := client.Order.Create(data, nil)

```csharp: .NET
RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

Dictionary orderRequest = new Dictionary();
orderRequest.Add("amount", 0);
orderRequest.Add("currency", "INR");
orderRequest.Add("customer_id", "cust_JDdNazagOgg9Ig");
orderRequest.Add("method", "nach");
orderRequest.Add("receipt", "receipt#1");
Dictionary notes = new Dictionary();
notes.Add("notes_key_1","Tea, Earl Grey, Hot");
notes.Add("notes_key_2","Tea, Earl Grey… decaf.");
orderRequest.Add("notes", notes);
Dictionary token = new Dictionary();
token.Add("auth_type","physical");
token.Add("max_amount","10000000");
token.Add("expire_at","2709971120");
Dictionary tokenNotes = new Dictionary();
tokenNotes.Add("notes_key_1","Tea, Earl Grey, Hot");
tokenNotes.Add("notes_key_2","Tea, Earl Grey… decaf.");
token.Add("notes",tokenNotes);
orderRequest.Add("token", token);
Dictionary bankAccount = new Dictionary();
bankAccount.Add("beneficiary_name","Gaurav Kumar");
bankAccount.Add("account_number","11214311215411");
bankAccount.Add("account_type","savings");
bankAccount.Add("ifsc_code","HDFC0001233");
token.Add("bank_account",bankAccount);
Dictionary nach = new Dictionary();
nach.Add("form_reference1","Recurring Payment for Gaurav Kumar");
nach.Add("form_reference2","Method Paper NACH");
nach.Add("description","Paper NACH Gaurav Kumar");
token.Add("nach",nach);

Order order = client.Order.Create(orderRequest);
````

````json: Success Response theme={null}
{
   "id":"order_1Aa00000000001",
   "entity":"order",
   "amount":0,
   "amount_paid":0,
   "amount_due":0,
   "currency":"INR",
   "receipt":"rcptid #10",
   "offer_id":null,
   "offers":{
      "entity":"collection",
      "count":0,
      "items":[
         
      ]
   },
   "status":"created",
   "attempts":0,
   "notes":{
      "notes_key_1":"Beam me up Scotty",
      "notes_key_2":"Engage"
   },
   "created_at":1579775420,
   "token":{
      "method":"nach",
      "notes":{
         "notes_key_1":"Tea, Earl Grey, Hot",
         "notes_key_2":"Tea, Earl Grey… decaf."
      },
      "recurring_status":null,
      "failure_reason":null,
      "currency":"INR",
      "max_amount":10000000,
      "auth_type":"physical",
      "expire_at":1580480689,
      "nach":{
         "create_form":true,
         "form_reference1":"Recurring Payment for Gaurav Kumar",
         "form_reference2":"Method Paper NACH",
         "prefilled_form":"https://rzp.io/i/bitw",
         "upload_form_url":"https://rzp.io/i/gts",
         "description":"Paper NACH Gaurav Kumar"
      },
      "bank_account":{
         "ifsc":"HDFC0000001",
         "bank_name":"HDFC Bank",
         "name":"Gaurav Kumar",
         "account_number":"11214311215411",
         "account_type":"savings",
         "beneficiary_email":"gaurav.kumar@example.com",
         "beneficiary_mobile":"9876543210"
      },
      "first_payment_amount":0
   }
}

```json: Failure Response
{
   "error":{
      "code":"BAD_REQUEST_ERROR",
      "description":"The id provided does not exist",
      "source":"business",
      "step":"payment_initiation",
      "reason":"input_validation_failed",
      "metadata":{
         
      }
   }
}
````

#### Request Parameters

`amount` *mandatory*
: `integer` Amount in currency subunits. For Paper NACH, the amount has to be `0`.

`currency` *mandatory*
: `string` The 3-letter ISO currency code for the payment. Currently, we only support `INR`.

`method` *mandatory*
: `string` The authorisation method. In this case the value will be `nach`.

`customer_id` *mandatory*
: `string` The unique identifier of the customer, who is to be charged. For example, `cust_D0cs04OIpPPU1F`.

`receipt` *optional*
: `string` A user-entered unique identifier for the order. For example, `rcptid #1`. This parameter should be mapped to the `order_id` sent by Razorpay.

`notes`*optional*
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`token`
: Details related to the authorisation such as max amount, bank account information and NACH information.

`auth_type` *mandatory*
: `string` In this case, it will be `physical`.

`bank_account`
: Customer's bank account details that will be printed on the NACH form.

`account_number`*mandatory*
: `string` Customer's bank account number. For example `11214311215411`.

`ifsc_code`*mandatory*
: `string` Customer's bank IFSC. For example `UTIB0000001`.

`beneficiary_name`*mandatory*
: `string` Customer's name. For example, `Gaurav Kumar`.

`account_type` *optional*
: `string` Customer's bank account type. Possible values:

* `savings` (default)
* `current`
* `cc` (Cash Credit)
* `nre` (SB-NRE)
* `nro` (SB-NRO)

`max_amount` *optional*
: `integer` Use to set the maximum amount per debit request. Know about [maximum and default values](/payments/recurring-payments/paper-nach/faqs#3-is-there-a-limit-on-the-debit).

`expire_at` *optional*
: `integer` Timestamp, in Unix, that specifies when the registration link should expire. The value can range from the current date to 01-19-2038 (`2147483647`).

`nach`
: Additional information to be printed on the NACH form that your customer will sign.

`form_reference1` *optional*
: `string` A user-entered reference that appears on the NACH form.

`form_reference2` *optional*
: `string` A user-entered reference that appears on the NACH form.

`description` *optional*
: `string` A user-entered description that appears on the hosted page. For example, `Form for Gaurav Kumar.`

`notes`*optional*
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

#### Response Parameters

`id`
: `string` A unique identifier of the order created. For example `order_1Aa00000000001`.

`entity`
: `string` The entity that is created. Here it is `order`.

`amount`
: `integer` Amount in currency subunits. For NACH, the amount should be `0`.

`amount_paid`
: `integer` The amount that has been paid.

`amount_due`
: `integer` The amount that is yet to pay.

`currency`
: `string` The 3-letter ISO currency code for the payment. Currently, we only support `INR`.

`receipt`
: `string` A user-entered unique identifier of the order. For example, `rcptid #10`. You should map this parameter to the `order_id` sent by Razorpay.

`status`
: `string` The status of the order. Here, it is `created`.

`notes`
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`created_at`
: `integer` The Unix timestamp at which the order was created.

`token`
: Details related to the authorisation such as max amount and bank account information.

`method`
: `string` Payment method used to make the authorisation payment. Here, it is `nach`.

`notes`
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`max_amount`
: `integer` The maximum amount in paise a customer can be charged in a transaction. Know about [maximum and default values](/payments/recurring-payments/paper-nach/faqs#3-is-there-a-limit-on-the-debit).

`expire_at`
: `integer` The Unix timestamp to indicate the date till which you can use the token (authorisation on the payment method) to charge the customer subsequent payments.

`auth_type`
: `string` NACH type used to make the authorisation payment. Here, it is `physical`.

`nach`
: Additional information to be printed on the NACH form that your customer will sign.

`create_form`
: `boolean` Indicates whether the form is created or not. Possible values: - `true`: The NACH form is created.

* `false`: The NACH form is not created.

`form_reference1`
: `string` A user-entered reference that appears on the NACH form.

`form_reference2`
: `string` A user-entered reference that appears on the NACH form.

`prefilled_form`
: `string` The link from where you can download the pre-filled NACH form.

`upload_form_url`
: `string` The link where the NACH form should be uploaded once it is signed by the customer.

`description`
: `string` A user-entered description that appears on the hosted page. For example, `Paper NACH Gaurav Kumar`.

`bank_account`
: Customer's bank account details that should be pre-filled on the checkout.

`ifsc_code`
: `string` Customer's bank IFSC. For example, `HDFC0000001`.

`bank_name`
: `string` The bank name. For example, `HDFC Bank`.

`name`
: `string` Name of the beneficiary. For example, `Gaurav Kumar`.

`account_number`
: `string` Customer's bank account number.

`account_type`
: `string` Customer's bank account type. Possible values:

* `savings` (default)
* `current`
* `cc` (Cash Credit)
* `nre` (SB-NRE)
* `nro` (SB-NRO)

`beneficiary_email`
: `string` Email address of the beneficiary. For example, `gaurav.kumar@example.com`.

`beneficiary_mobile`
: `integer` Mobile number of the beneficiary.

<Info>
  **Download and Upload the Pre-filled NACH Form**
</Info>

Once the order is created, the pre-filled form must be downloaded, signed by your customer and uploaded back to Razorpay to complete the transaction.

You receive the following parameters as part of the response:

`prefilled_form`
: The link from where you can download the pre-filled NACH form.

`upload_form_url`
: The link where the NACH form should be uploaded once it is signed by the customer.

**Authorisation transaction + auto-charge first payment**:

You can register a customer's mandate **and** charge them the first recurring payment as part of the same transaction. Refer to the [Paper NACH section under Registration and Charge First Payment Together](/api/payments/recurring-payments/paper-nach/auto-debit#1-create-an-authorization-transaction) for more information.

#### Error Response Parameters

Given below is a list of possible errors you may face while creating an Order.

## Error | Cause | Solution

## The id provided does not exist | This error occurs when you enter an incorrect `customer_id`. | Make sure to enter a valid `customer_id`.

## The api key provided is invalid | This error occurs when you enter the wrong API key or secret. | Make sure to enter a valid API key and secret.

## The amount should be 0. | This error occurs when you enter an amount greater than INR 0. | Make sure to enter the amount is INR 0.

## Invalid IFSC Code | This error occurs when you enter an incorrect IFSC code. | Make sure to enter a correct IFSC code.

## The currency should be INR when method is nach | This error occurs when you enter a currency other than INR | Make sure the currency is INR.

## The amount field is required. | This error occurs when you have not entered the amount or the `max_amount` value. | Make sure to enter the `max_amount` value.

## The minimum transaction amount allowed is Re. 5. | This error occurs when you enter the maximum amount less than the minimum amount. | Make sure the `max_amount` value is more than the `min_amount` value.

## invaild\_account\_number | This error occurs when you have not entered the `account_number`. | Make sure to enter a valid `account_number`.

selected\_frequency\_invalid | This error occurs when you enter an incorrect `frequency` parameter value. | Make sure to enter a correct `frequency` parameter value.

### 1.1.3. Create an Authorisation Payment

You should create an authorisation payment after you create an order.

To create an authorisation payment:

1. Download the Paper NACH form and send it to the customer.
2. Ask the customers to fill the form and either [Upload via Checkout](#1131-upload-the-nach-file-via-checkout) or send it to you to upload the form using the [create NACH File API](#1132-upload-the-nach-file-via-api).

#### 1.1.3.1 Upload the NACH File via Checkout

Create a payment checkout form for customers to upload the NACH form and make the Authorisation Transaction. You can use the Handler Function or Callback URL.

## **Handler Function** | **Callback URL**

When you use the handler function, the response object of the successful payment (`razorpay_payment_id`, `razorpay_order_id` and `razorpay_signature`) is submitted to the Checkout form. You need to collect these and send them to your server. | When you use a Callback URL, the response object of the successful payment (`razorpay_payment_id`, `razorpay_order_id` and `razorpay_signature`) is submitted to the Callback URL.

<Warning>
  **Watch Out!**

  The Callback URL is not supported for Recurring Payments created using the registration link.

  ````html: Checkout with handler functions theme={null}
   Pay 
     
    
      var options = {
        "key": "[YOUR_KEY_ID]",
        "order_id": "order_1Aa00000000001",
        "customer_id": "cust_1Aa00000000001",
        "recurring": true,
        "handler": function (response) {
          alert(response.razorpay_payment_id);
          alert(response.razorpay_order_id);
          alert(response.razorpay_signature);
        },
        "notes": {
          "note_key 1": "Beam me up Scotty",
          "note_key 2": "Tea. Earl Gray. Hot."
        },
        "theme": {
          "color": "#F37254"
        }
      };
      var rzp1 = new Razorpay(options);
      document.getElementById('rzp-button1').onclick = function (e) {
        rzp1.open();
        e.preventDefault();
      }
    
  ```html: Manual checkout with Callback URL
   Pay 
     
    
      var options = {
        "key": "[YOUR_KEY_ID]",
        "order_id": "order_1Aa00000000001",
        "customer_id": "cust_1Aa00000000001",
        "recurring": true,
        "callback_url": "https://eneqd3r9zrjok.x.pipedream.net/",
        "notes": {
          "note_key 1": "Beam me up Scotty",
          "note_key 2": "Tea. Earl Gray. Hot."
        },
        "theme": {
          "color": "#F37254"
        }
      };
      var rzp1 = new Razorpay(options);
      document.getElementById('rzp-button1').onclick = function (e) {
        rzp1.open();
        e.preventDefault();
      }
    
  ````

  #### Additional Checkout Fields

  `customer_id` *mandatory*
  : `string` Unique identifier of the customer created in the [first step](#111-create-a-customer).

  `order_id` *mandatory*
  : `string` Unique identifier of the  order created in the [second step](#112-create-an-order).

  `recurring` *mandatory*
  : `boolean` Determines whether the recurring is enabled or not. Possible values:

  * `true`: Recurring payment is enabled.
  * `false`: Recurring payment is not enabled.

  #### Error Response Parameters

  Given below is a list of possible errors you may face while making the authorisation payment.
</Warning>

### adequate\_funds\_not\_available\_blocked

* **Description**: Sufficient unblocked funds not available in customer's account. Please ask customer to add fund and try again.
* **Next Steps**: Please ask customer to add sufficient unblocked funds and try again.

### bad\_request\_error

* **Description**: Invalid Mandate Sequence Number.
* **Next Steps**: Retry after some time during the valid cycle.

### bank\_account\_invalid

* **Description**: Payment failed because Account linked to VPA is invalid.
* **Next Steps**: Create a new mandate with the customer.

### bank\_account\_validation\_failed

* **Description**: Payment was unsuccessful as the details are invalid. Please retry with the right details.
* **Next Steps**: Ask the customer to retry again.

### bank\_not\_available

* **Description**: Payment was unsuccessful as the bank linked to this UPI ID is temporarily unavailable. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### bank\_technical\_error

Bank Temporarily Unavailable

* **Description**: Payment was unsuccessful as the bank linked to this UPI ID is temporarily unavailable. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### Temporary Bank Issue

* **Description**: Payment was unsuccessful due to a temporary issue at your bank. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### Bank Declined

* **Description**: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### Bank or Wallet Gateway Error

* **Description**: Payment processing failed due to error at bank or wallet gateway.
* **Next Steps**: Retry after some time.

### General Temporary Issue

* **Description**: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### Bank Services Halt

* **Description**: Payment was unsuccessful due to a temporary halt of services at this bank.
* **Next Steps**: Retry after some time.

### credit\_to\_beneficiary\_failed

* **Description**: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### debit\_declined

* **Description**: Payment was unsuccessful as it was declined by remitter bank.
* **Next Steps**: Create a new mandate with the customer.

### debit\_instrument\_blocked

* **Description**: Payment was unsuccessful as the account linked to this UPI ID is blocked. Try using another account.
* **Next Steps**: Create a new mandate with the customer.

### duplicate\_mandate\_request

* **Description**: Duplicate mandate request. Please try again with another mandate request.
* **Next Steps**: Please try again with another mandate request.

### gateway\_technical\_error

Bank or Wallet Gateway Error

* **Description**: Payment processing failed due to error at bank or wallet gateway.
* **Next Steps**: Retry after some time.

### Temporary Issue with Money Deduction

* **Description**: Payment was unsuccessful due to a temporary issue. If money got deducted, reach out to the seller.
* **Next Steps**: Retry after some time.

### incorrect\_pin

* **Description**: You have entered an incorrect PIN on the UPI app. Please retry with the correct PIN.
* **Next Steps**: Ask the customer to retry with correct PIN.

### insufficient\_funds

* **Description**: Transaction failed due to insufficient funds.
* **Next Steps**: Ask the customer to add balance to their account and retry.

### invalid\_request

* **Description**: Payment processing failed due to error at bank or wallet gateway.
* **Next Steps**: Retry after some time.

### invalid\_response\_from\_gateway

* **Description**: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### invalid\_transaction\_beneficiary

* **Description**: Beneficiary address resolution failed. Please try again after some time.
* **Next Steps**: Please try again after some time.

### invalid\_vpa

* **Description**: You have entered an incorrect UPI ID. Please retry with the correct UPI ID.
* **Next Steps**: Ask the customer to retry with a valid VPA.

### issuer\_dispatch\_failed

* **Description**: Payment failed due to some issue at the issuer bank. Please try again after some time.
* **Next Steps**: Please try again after some time.

### limit\_exceeded\_remitting\_bank

* **Description**: Limit exceeded for remitter bank. Please ask customer to try with another bank account.
* **Next Steps**: Please ask customer to try with another bank account.

### mandate\_debit\_beyond\_psp\_amount\_cap

* **Description**: Debit amount is beyond payer PSP specified amount cap. Please reduce the amount and try again.
* **Next Steps**: Please reduce the mandate amount to match customer PSP.

### mandate\_request\_limit\_breached

* **Description**: Maximum number of mandate creation requests exceeded for customer's bank account. Please wait for some time before initiating new mandate creation requests.
* **Next Steps**: Please wait for some time before initiating new mandate creation requests.

### mobile\_number\_invalid

* **Description**: Registered Mobile number linked to the account has been changed or removed.
* **Next Steps**: Create a new mandate with the customer.

### nature\_of\_debit\_not\_allowed

* **Description**: Nature of debit not allowed in customer's account. Please ask the customer to use a different bank account.
* **Next Steps**: Please ask the customer to use a different bank account.

### no\_financial\_address\_record\_found

* **Description**: No financial address record found for this VPA. Please ask customer to try with another bank account.
* **Next Steps**: Please ask customer to try with other bank account.

### no\_original\_request\_found

* **Description**: No mandate details were found in the record during debit. Please try after some time.
* **Next Steps**: Please try after some time.

### payment\_collect\_request\_expired

* **Description**: Payment was unsuccessful as you could not pay with the UPI app within time.
* **Next Steps**: Retry after some time.

### payment\_declined

Bank Declined Payment

* **Description**: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Ask the customer to retry with other account.

### Customer Declined Payment

* **Description**: You have declined the payment request on the UPI app. Please retry when you are ready.
* **Next Steps**: Ask the customer to approve the payment.

### payment\_failed

* **Description**: Payment was unsuccessful due to a temporary issue. If amount got deducted, it will be refunded within 5-7 working days.
* **Next Steps**: Retry after 1 hour.

### payment\_pending

* **Description**: The status of your payment is pending. You can either wait or retry to pay successfully.
* **Next Steps**: Retry after some time.

### payment\_risk\_check\_failed

* **Description**: Payment was unsuccessful as your account does not pass the risk checks done by your bank. Try using another account.
* **Next Steps**: Retry after some time.

### payment\_timed\_out

* **Description**: Payment was unsuccessful as you could not complete it in time.
* **Next Steps**: Retry after some time.

### pre\_debit\_notification\_failed

* **Description**: Unable to Notify the Customer.
* **Next Steps**: Retry after some time.

### remitter\_dispatch\_failed

* **Description**: Payment failed due to some issue at the customer's. Please try again after some time.
* **Next Steps**: Please try again after some time.

### request\_timed\_out

General Timeout - Temporary Issue

* **Description**: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### Timeout - Bank Declined

* **Description**: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### Timeout - Recurring Payment Creation

* **Description**: Payment was unsuccessful as the recurring payment can not be created at this time. Any amount deducted will be refunded within 5-7 working days.
* **Next Steps**: Retry after some time.

### transaction\_frequency\_limit\_exceeded

* **Description**: Payment failed. Please try again with another bank account.
* **Next Steps**: Create a new mandate with the customer.

### transaction\_limit\_exceeded

Amount Limit Exceeded

* **Description**: Payment failed because Transaction amount limit has exceeded.
* **Next Steps**: Reach out to the customer to collect the amount.

### Bank Account Amount Limit

* **Description**: Payment was unsuccessful as you exceeded the amount limit on the bank account linked to this UPI id.
* **Next Steps**: Ask the customer to retry after some time.

### transaction\_not\_allowed

* **Description**: Payment was unsuccessful as it was declined by your bank. Reach out to your bank for more details. Try using another account.
* **Next Steps**: Create a new mandate with the customer.

### upi\_dummy\_payment

* **Description**: Payment was a dummy payment for one time mandate registration.
* **Next Steps**: NA

#### 1.1.3.2 Upload the NACH File via API

Use the following API to upload the NACH file sent by the customer.

```cURL: Request theme={null}
curl -u : \
-X POST 'https://api.razorpay.com/v1/payments/create/nach/file' \
-H "Content-Type: multipart/form-data" \
-F 'order_id=order_FoLdZrq6QGKUWg' \
-F 'recurring=1' \
-F 'file=@/Users/your_name/sample_uploaded.jpeg' // file path
```

````json: Successful Response theme={null}
{
  "razorpay_payment_id": "pay_FjDn43bvssCqEM",
  "razorpay_order_id": "order_FjDdQ6a0GluJ2c",
  "razorpay_signature": "f13775ea8a91e9bf229b9fdba3ad783f7ff2bdbce1c35e87a69ae7418808da04"
}
```json: Failure Response
{
   "error":{
      "code":"BAD_REQUEST_ERROR",
      "description":"file size exceeds limit",
      "field":null,
      "source":"customer",
      "step":"form_upload",
      "reason":"file size exceeds limit",
      "metadata":{
         "payment_id":null,
         "order_id":"order_DBJKIP31Y4jl8"
      }
   }
}
````

#### Request Parameters

`order_id` *mandatory*
: `string` The unique identifier of the order that was created. For example, `order_FoLdZrq6QGKUWg`.

`recurring` *mandatory*
: `boolean` Determines whether the recurring is enabled or not. Possible values:

* `1`: Recurring is enabled.
* `0`: Recurring is not enabled.

`file` *mandatory*
: `strinng` The path where you have saved the NACH file.

#### Response Parameters

`razorpay_payment_id`
: `string` The unique identifier of the payment that is created. For example, `pay_FjDn43bvssCqEM`.

`razorpay_order_id`
: `string` The unique identifier of the order that is created. For example, `order_FjDdQ6a0GluJ2c`.

`razorpay_signature`
: `string` The signature generated by the Razorpay. For example, `f13775ea8a91e9bf229b9fdba3ad783f7ff2bdbce1c35e87a69ae7418808da04`

#### Error Response Parameters

Given below is a list of possible errors you may face while while uploading a NACH file.

## Error | Cause | Solution

## `unknown_file_type` | This error occurs when the file type of the image is not supported. | Make sure the image is in either `.jpeg`, `.jpg` or `.png` formats.

## `file_size_exceeds_limit` | This error occurs when the file size exceeds the permissible limits. | Make sure to upload an image of a smaller size.

## `image_not_clear` | This error occurs when the uploaded image is not clear. This can either be due to poor resolution or because part of the image is cropped. | Make sure to upload an image with better quality.

## `form_mismatch` | This error occurs when the ID of the uploaded form does not match that in our records. | Make sure to upload the image against the correct order ID.

## `form_signature_missing` | This error occurs when the signature of the customer is either missing or could not be detected. | Check that the customer has signed in the appropriate box and that the image uploaded is clear. For current accounts, a company stamp may also be required.

## `form_data_mismatch` | This error occurs when one or more of the fields on the NACH form do not match with that in our records. | Check that the image is clear and the data has not been tampered with before uploading again.

## `form_status_pending` | This error occurs when a form against the order is pending action on the destination bank. You cannot submit a new form till you receive a status. | Wait for an update from the destination bank on the approval/rejection of the mandate.

## 1.2. Using a Registration Link

Registration Link is an alternate way of creating an authorisation transaction. You can create a registration link using the [API](#121-create-a-registration-link) or [Dashboard](/payments/recurring-payments/create#1-create-a-registration-link).

<Info>
  **Handy Tips**
</Info>

You do not have to create a customer if you choose the registration link method for creating an authorisation transaction.

* When you create a registration link, an [invoice](/payments/invoices) is automatically issued to the customer. They can use this invoice to make the authorisation payment.
* A registration link should always have an order amount (in paise) the customer will be charged when making the authorisation payment. This amount should be `0` in the case of Paper NACH.

<Info>
  **Handy Tips**
</Info>

You can [use Webhooks to get notifications about successful payments](/api/payments/recurring-payments/webhooks#check-authorization-link-status-using-webhooks) against a registration link.

### 1.2.1. Create a Registration Link

The following endpoint creates a registration link for recurring payments.

/subscription\_registration/auth\_links

````cURL: Curl theme={null}
curl -u :
-X POST https://api.razorpay.com/v1/subscription_registration/auth_links
-H "Content-Type: application/json" \
-d '{
  "customer":{
    "name":"Gaurav Kumar",
    "email":"gaurav.kumar@example.com",
    "contact":"9123456780"
  },
  "amount":0,
  "currency":"INR",
  "type":"link",
  "description":"12 p.m. Meals",
  "subscription_registration":{
    "method":"nach",
    "auth_type":"physical",
    "bank_account":{
      "beneficiary_name":"Gaurav Kumar",
      "account_number":"11214311215411",
      "account_type":"savings",
      "ifsc_code":"HDFC0001233"
    },
    "nach":{
      "form_reference1":"Recurring Payment for Gaurav Kumar",
      "form_reference2":"Method Paper NACH"
    },
    "expire_at":1947483647,
    "max_amount":50000
  },
  "receipt":"Receipt No. 1",
  "sms_notify":true,
  "email_notify":true,
  "expire_by":1647483647,
  "notes":{
    "note_key 1":"Beam me up Scotty",
    "note_key 2":"Tea. Earl Gray. Hot."
  }
}'

```java: Java
RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

JSONObject registrationLinkRequest = new JSONObject();
JSONObject customer = new JSONObject();
customer.put("name","Gaurav Kumar");
customer.put("email","gaurav.kumar@example.com");
customer.put("contact","9123456780");
registrationLinkRequest.put("customer", customer);
registrationLinkRequest.put("type", "link");
registrationLinkRequest.put("amount", 0);
registrationLinkRequest.put("currency", "INR");
registrationLinkRequest.put("description", "12 p.m. Meals");
JSONObject subscriptionRegistration = new JSONObject();
subscriptionRegistration.put("method","nach");
subscriptionRegistration.put("auth_type","physical");
subscriptionRegistration.put("max_amount",50000);
subscriptionRegistration.put("expire_at",1609423824);
JSONObject bankAccount = new JSONObject();
bankAccount.put("beneficiary_name","Gaurav Kumar");
bankAccount.put("account_number","11214311215411");
bankAccount.put("account_type","savings");
bankAccount.put("ifsc_code","HDFC0001233");
JSONObject nach = new JSONObject();
nach.put("form_reference1","Recurring Payment for Gaurav Kumar");
nach.put("form_reference2","Method Paper NACH");
subscriptionRegistration.put("bank_account",bankAccount);
subscriptionRegistration.put("nach",nach);
registrationLinkRequest.put("subscription_registration", subscriptionRegistration);
registrationLinkRequest.put("receipt", "Receipt No. #1");
registrationLinkRequest.put("email_notify", true);
registrationLinkRequest.put("sms_notify", true);
registrationLinkRequest.put("expire_by", 1580479824);
JSONObject notes = new JSONObject();
notes.put("notes_key_1","Tea, Earl Grey, Hot");
notes.put("notes_key_2","Tea, Earl Grey… decaf.");
registrationLinkRequest.put("notes", notes);

Invoice invoice = razorpay.invoices.createRegistrationLink(registrationLinkRequest);

```php: PHP
$api = new Api($key_id, $secret);

$api->subscription->createSubscriptionRegistration(array('customer' => array('name' => 'Gaurav Kumar','email' => 'gaurav.kumar@example.com','contact' => '9123456780'),'amount' => 0,'currency' => 'INR','type' => 'link','description' => '12 p.m. Meals','subscription_registration' => array('method' => 'nach','auth_type' => 'physical','bank_account' => array('beneficiary_name' => 'Gaurav Kumar','account_number' => '11214311215411','account_type' => 'savings','ifsc_code' => 'HDFC0001233'),'nach' => array('form_reference1' => 'Recurring Payment for Gaurav Kumar','form_reference2' => 'Method Paper NACH'),'expire_at' => 1947483647,'max_amount' => 50000),'receipt' => 'Receipt No. 1','sms_notify' => true,'email_notify' => true,'expire_by' => 1647483647,'notes' => array('note_key 1' => 'Beam me up Scotty','note_key 2' => 'Tea. Earl Gray. Hot.')));
```javascript: Node.js
var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

instance.payments.createRecurringPayment({
  customer: {
    name: "Gaurav Kumar",
    email: "gaurav.kumar@example.com",
    contact: 9123456780
  },
  amount: 0,
  currency: "INR",
  type: "link",
  description: "12 p.m. Meals",
  subscription_registration: {
    method: "nach",
    auth_type: "physical",
    bank_account: {
      beneficiary_name: "Gaurav Kumar",
      account_number: 11214311215411,
      account_type: "savings",
      ifsc_code: "HDFC0001233"
    },
    nach: {
      form_reference1: "Recurring Payment for Gaurav Kumar",
      form_reference2: "Method Paper NACH"
    },
    expire_at: 1947483647,
    max_amount: 50000
  },
  receipt: "Receipt No. 1",
  sms_notify: true,
  email_notify: true,
  expire_by: 1647483647,
  notes: {
    "note_key 1": "Beam me up Scotty",
    "note_key 2": "Tea. Earl Gray. Hot."
  }
})
```python: Python
client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

client.registration_link.create({
    'customer': {'name': 'Gaurav Kumar',
                 'email': 'gaurav.kumar@example.com',
                 'contact': 9123456780},
    'amount': 0,
    'currency': 'INR',
    'type': 'link',
    'description': '12 p.m. Meals',
    'subscription_registration': {
        'method': 'nach',
        'auth_type': 'physical',
        'bank_account': {
            'beneficiary_name': 'Gaurav Kumar',
            'account_number': 11214311215411,
            'account_type': 'savings',
            'ifsc_code': 'HDFC0001233',
            },
        'nach': {'form_reference1': 'Recurring Payment for Gaurav Kumar'
                 , 'form_reference2': 'Method Paper NACH'},
        'expire_at': 1947483647,
        'max_amount': 50000,
        },
    'receipt': 'Receipt No. 1',
    'sms_notify': True,
    'email_notify': True,
    'expire_by': 1647483647,
    'notes': {'note_key 1': 'Beam me up Scotty',
              'note_key 2': 'Tea. Earl Gray. Hot.'}
    })

```ruby: Ruby
require "razorpay"
Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

para_attr = {
  "customer": {
    "name": "Gaurav Kumar",
    "email": "gaurav.kumar@example.com",
    "contact": 9123456780
  },
  "amount": 0,
  "currency": "INR",
  "type": "link",
  "description": "12 p.m. Meals",
  "subscription_registration": {
    "method": "nach",
    "auth_type": "physical",
    "bank_account": {
      "beneficiary_name": "Gaurav Kumar",
      "account_number": 11214311215411,
      "account_type": "savings",
      "ifsc_code": "HDFC0001233"
    },
    "nach": {
      "form_reference1": "Recurring Payment for Gaurav Kumar",
      "form_reference2": "Method Paper NACH"
    },
    "expire_at": 1947483647,
    "max_amount": 50000
  },
  "receipt": "Receipt No. 1",
  "sms_notify": 1,
  "email_notify": 1,
  "expire_by": 1647483647,
  "notes": {
    "note_key 1": "Beam me up Scotty",
    "note_key 2": "Tea. Earl Gray. Hot."
  }
}

Razorpay::SubscriptionRegistration.create(para_attr)

```go: Go
import ( razorpay "github.com/razorpay/razorpay-go" )
client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

data:= map[string]interface{}{
  "customer":map[string]interface{}{
    "name":"Gaurav Kumar",
    "email":"gaurav.kumar@example.com",
    "contact":"9123456780",
  },
  "amount":0,
  "currency":"INR",
  "type":"link",
  "description":"12 p.m. Meals",
  "subscription_registration":map[string]interface{}{
    "method":"nach",
    "auth_type":"physical",
    "bank_account":map[string]interface{}{
      "beneficiary_name":"Gaurav Kumar",
      "account_number":"11214311215411",
      "account_type":"savings",
      "ifsc_code":"HDFC0001233",
    },
    "nach":map[string]interface{}{
      "form_reference1":"Recurring Payment for Gaurav Kumar",
      "form_reference2":"Method Paper NACH",
    },
    "expire_at":1947483647,
    "max_amount":50000,
  },
  "receipt":"Receipt No. 1",
  "sms_notify":true,
  "email_notify":true,
  "expire_by":1647483647,
  "notes":map[string]interface{}{
    "note_key 1":"Beam me up Scotty",
    "note_key 2":"Tea. Earl Gray. Hot.",
  },
}

body, err := client.Invoice.CreateRegistrationLink(data, nil)

```csharp: .NET
RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

Dictionary registrationLinkRequest = new Dictionary();
Dictionary customer = new Dictionary();
customer.Add("name","Gaurav Kumar");
customer.Add("email","gaurav.kumar@example.com");
customer.Add("contact","9123456780");
registrationLinkRequest.Add("customer", customer);
registrationLinkRequest.Add("type", "link");
registrationLinkRequest.Add("amount", 0);
registrationLinkRequest.Add("currency", "INR");
registrationLinkRequest.Add("description", "12 p.m. Meals");
Dictionary subscriptionRegistration = new Dictionary();
subscriptionRegistration.Add("method","nach");
subscriptionRegistration.Add("auth_type","physical");
subscriptionRegistration.Add("max_amount",50000);
subscriptionRegistration.Add("expire_at",1609423824);
Dictionary bankAccount = new Dictionary();
bankAccount.Add("beneficiary_name","Gaurav Kumar");
bankAccount.Add("account_number","11214311215411");
bankAccount.Add("account_type","savings");
bankAccount.Add("ifsc_code","HDFC0001233");
Dictionary nach = new Dictionary();
nach.Add("form_reference1","Recurring Payment for Gaurav Kumar");
nach.Add("form_reference2","Method Paper NACH");
subscriptionRegistration.Add("bank_account",bankAccount);
subscriptionRegistration.Add("nach",nach);
registrationLinkRequest.Add("subscription_registration", subscriptionRegistration);
registrationLinkRequest.Add("receipt", "Receipt No. #111");
registrationLinkRequest.Add("email_notify", true);
registrationLinkRequest.Add("sms_notify", true);
registrationLinkRequest.Add("expire_by", 1580479824);
Dictionary notes = new Dictionary();
notes.Add("notes_key_1","Tea, Earl Grey, Hot");
notes.Add("notes_key_2","Tea, Earl Grey… decaf.");
registrationLinkRequest.Add("notes", notes);

Invoice invoice = client.Invoice.CreateRegistrationLink(registrationLinkRequest);

```json: Response
{
    "id": "inv_FHrZiAubEzDdaq",
    "entity": "invoice",
    "receipt": "Receipt No. 1",
    "invoice_number": "Receipt No. 1",
    "customer_id": "cust_BMB3EwbqnqZ2EI",
    "customer_details": {
        "id": "cust_BMB3EwbqnqZ2EI",
        "name": "Gaurav Kumar",
        "email": "gaurav.kumar@example.com",
        "contact": "9123456780",
        "gstin": null,
        "billing_address": null,
        "shipping_address": null,
        "customer_name": "Gaurav Kumar",
        "customer_email": "gaurav.kumar@example.com",
        "customer_contact": "9123456780"
    },
    "order_id": "order_FHrZiBOkWHZPOp",
    "line_items": [],
    "payment_id": null,
    "status": "issued",
    "expire_by": 1647483647,
    "issued_at": 1595491154,
    "paid_at": null,
    "cancelled_at": null,
    "expired_at": null,
    "sms_status": "sent",
    "email_status": "sent",
    "date": 1595491154,
    "terms": null,
    "partial_payment": false,
    "gross_amount": 0,
    "tax_amount": 0,
    "taxable_amount": 0,
    "amount": 0,
    "amount_paid": 0,
    "amount_due": 0,
    "currency": "INR",
    "currency_symbol": "₹",
    "description": "12 p.m. Meals",
    "notes": {
        "note_key 1": "Beam me up Scotty",
        "note_key 2": "Tea. Earl Gray. Hot."
    },
    "comment": null,
    "short_url": "https://rzp.io/i/bzDYbNg",
    "view_less": true,
    "billing_start": null,
    "billing_end": null,
    "type": "link",
    "group_taxes_discounts": false,
    "created_at": 1595491154,
    "idempotency_key": null,
    "token": {
        "method": "nach",
        "notes": {
            "note_key 1": "Beam me up Scotty",
            "note_key 2": "Tea. Earl Gray. Hot."
        },
        "recurring_status": null,
        "failure_reason": null,
        "currency": "INR",
        "max_amount": 50000,
        "auth_type": "physical",
        "expire_at": 1947483647,
        "nach": {
            "create_form": true,
            "form_reference1": "Recurring Payment for Gaurav Kumar",
            "form_reference2": "Method Paper NACH",
            "prefilled_form": "https://rzp.io/i/exdIzYN",
            "upload_form_url": "https://rzp.io/i/bzDYbNg",
            "description": "12 p.m. Meals"
        },
        "bank_account": {
            "ifsc": "HDFC0001233",
            "bank_name": "HDFC Bank",
            "name": "Gaurav Kumar",
            "account_number": "11214311215411",
            "account_type": "savings",
            "beneficiary_email": "gaurav.kumar@example.com",
            "beneficiary_mobile": "9123456780"
        },
        "first_payment_amount": 0
    },
    "nach_form_url": "https://rzp.io/i/exdIzYN"
}
````

#### Request Parameters

`customer`
: `object` Details of the customer to whom the registration link is sent.

`name` *mandatory*
: `string` Customer's name.

`email` *mandatory*
: `string` Customer's email address.

`contact`*mandatory*
: `integer` Customer's contact number.

`type` *mandatory*
: `string` In this case, the value is `link`.

`amount` *mandatory*
: `integer` The payment amount in the smallest currency sub-unit.

`currency` *mandatory*
: `string` The 3-letter ISO currency code for the payment.

`description` *mandatory*
: `string` A description that appears on the hosted page.

`subscription_registration`
: Details of the authorisation payment.

`method` *mandatory*
: `string` The Paper NACH method used to make the authorisation transaction. Here, it is `physical`.

`auth_type` *mandatory*
: `string` The payment method used to make the authorisation transaction. Here, it is `nach`.

`bank_account`
: The customer's bank account details.

`beneficiary_name` *mandatory*
: `string` The beneficiary name. For example, `Gaurav Kumar`.

`account_number` *mandatory*
: `integer` The customer's bank account number. For example, `11214311215411`.

`account_type` *mandatory*
: `string` The customer's bank account type. Possible values:

* `savings`
* `current`

`ifsc_code` *mandatory*
: `string` The customer's bank IFSC. For example, `HDFC0000001`.

`max_amount` *optional*
: `integer` Use to set the maximum amount, in paise, per debit request. Know about [maximum and default values](/payments/recurring-payments/paper-nach/faqs#3-is-there-a-limit-on-the-debit).

`expire_at` *optional*
: `integer` The Unix timestamp till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. The default value is 10 years. The value can range from the current date to 31-12-2099 (`4101580799`).

`nach`
: Additional information to be printed on the NACH form your customer will sign.

`form_reference1` *optional*
: `string` A user entered reference that appears on the NACH form.

`form_reference2` *optional*
: `string` A user entered reference that appears on the NACH form.

`description` *optional*
: `string` A user entered description that appears on the hosted page. For example, `Form for Gaurav Kumar.`

`sms_notify` *optional*
: `boolean` Indicates if SMS notifications are to be sent by Razorpay. Possible values:

* `true` (default): Notifications are sent by Razorpay .
* `false`: Notifications are not sent by Razorpay.

`email_notify` *optional*
: `boolean` Indicates if email notifications are to be sent by Razorpay. Possible values:

* `true` (default): Notifications are sent by Razorpay .
* `false`: Notifications are not sent by Razorpay.

`expire_by` *optional*
: `integer` The Unix timestamp indicates the expiry of the registration link.

`receipt` *optional*
: `string` A unique identifier entered by you for the order. For example, `Receipt No. 1`. You should map this parameter to the `order_id` sent by Razorpay.

`notes` *optional*
: `object` This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

#### Response Parameters

`id`
: `string` The unique identifier of the invoice.

`entity`
: `string` The entity that has been created. Here, it is `invoice`.

`receipt`
: `string` A user-entered unique identifier of the invoice.

`invoice_number`
: `string` Unique number you added for internal reference.

`customer_id`
: `string` The unique identifier of the customer. For example, `cust_BMB3EwbqnqZ2EI`.

`customer_details`
: `object` Details of the customer.

`id`
: `string` The unique identifier associated with the customer to whom the invoice has been issued.

`name`
: `string` The customer's name.

`email`
: `string` The customer's email address.

`contact`
: `integer` The customer's phone number.

`billing_address`
: `string` Details of the customer's billing address.

`shipping_address`
: `string` Details of the customer's shipping address.

`order_id`
: `string` The unique identifier of the order associated with the invoice.

`line_items`
: `string` Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.

`payment_id`
: `string` Unique identifier of a payment made against the invoice.

`status`
: `string` The status of the invoice. Possible values:

* `draft`
* `issued`
* `partially_paid`
* `paid`
* `cancelled`
* `expired`
* `deleted`

`expire_by`
: `integer` The Unix timestamp at which the invoice will expire.

`issued_at`
: `integer` The Unix timestamp at which the invoice was issued to the customer.

`paid_at`
: `integer` The Unix timestamp at which the payment was made.

`cancelled_at`
: `integer` The Unix timestamp at which the invoice was cancelled.

`expired_at`
: `integer` The Unix timestamp at which the invoice expired.

`sms_status`
: `string` The delivery status of the SMS notification for the invoice sent to the customer. Possible values:

* `pending`
* `sent`

`email_status`
: `string` The delivery status of the email notification for the invoice sent to the customer. Possible values:

* `pending`
* `sent`

`date`
: `integer` Timestamp, in Unix format, that indicates the issue date of the invoice.

`terms`
: `string` Any terms to be included in the invoice. Maximum of 2048 characters.

`partial_payment`
: `boolean` Indicates whether the customer can make a partial payment on the invoice. Possible values:

* `true`:  The customer can make partial payments.
* `false` (default): The customer cannot make partial payments.

`amount`
: `integer` Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is 299.95, pass the value as `29995`.

`amount_paid`
: `integer` Amount paid by the customer against the invoice.

`amount_due`
: `integer` The remaining amount to be paid by the customer for the issued invoice.

`currency`
: `string` The currency associated with the invoice.

`description`
: `string`  A brief description of the invoice.

`notes`
: `object` Any custom notes added to the invoice. Maximum of 2048 characters.

`short_url`
: `string` The short URL that is generated. This is the link that can be shared with the customer to receive payments.

`type`
: `string` Here, it is `invoice`.

`comment`
: `string` Any comments to be added in the invoice. Maximum of 2048 characters.

### 1.2.2. Send/Resend Notifications

The following endpoint sends/resends notifications with the short URL to the customer:

/invoices/:id/notify\_by/:medium

### Sample Code

````cURL: Curl theme={null}
 curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET]
 -X POST https://api.razorpay.com/v1/invoices/inv_1Aa00000000001/notify_by/sms

 ```java: Java
 RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

 String invoiceId = "inv_1Aa00000000001";

 String medium = "sms";

 Invoice invoice = razorpay.invoices.notifyBy(invoiceId, medium);

 ```php: PHP
 $api = new Api($key_id, $secret);

 $api->invoice->fetch($invoiceId)->notify($medium);

 ```javascript: Node.js
 var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

 instance.invoices.notifyBy(invoiceId, medium)

 ```python: Python
 client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

 client.invoice.notify_by(invoiceId, medium)

 ```ruby: Ruby
 require "razorpay"
 Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

 invoiceId = "inv_JDdNb4xdf4gxQ7"

 medium = "email" 

 Razorpay::Invoice.notify_by(invoiceId, medium)

 ```go: Go
 import ( razorpay "github.com/razorpay/razorpay-go" )
 client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

 body, err := client.Invoice.Notify("", "", nil, nil)

 ```csharp: .NET
 RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

 string invoiceId = "inv_Z6t7VFTb9xHeOs";

 string medium = "sms";

 Invoice invoice = client.Invoice.Fetch(invoiceId).NotifyBy(medium);
````

```json: Response theme={null}
{
  "success": true
}
```

#### Path Parameters

`id`*mandatory*
: `string` The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, `inv_1Aa00000000001`.

`medium` *mandatory*
: `string` Determines through which medium you want to resend the notification. Possible values:

* `sms`
* `email`

#### Response Parameters

`success`
: `boolean` Indicates whether the notifications were sent successfully. Possible values:

* `true`: The notifications were successfully sent via SMS, email or both.
* `false`: The notifications were not sent.

### 1.2.3. Cancel a Registration Link

The following endpoint cancels a registration link.

/invoices/:id/cancel

````cURL: Curl theme={null}
curl -u :
-X POST https://api.razorpay.com/v1/invoices/inv_1Aa00000000001/cancel

```java: Java
RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

String invoiceId = "inv_1Aa00000000001";

Invoice invoice = razorpay.invoices.cancel(invoiceId);

```php: PHP
$api = new Api($key_id, $secret);

$api->invoice->fetch($invoiceId)->cancel();
```javascript: Node.js
var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

instance.invoices.cancel(invoiceId);
```python: Python
client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

client.invoice.cancel(invoiceId)

```ruby: Ruby
require "razorpay"
Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

invoiceId = "inv_1Aa00000000001"

Razorpay::Invoice.cancel(invoiceId)

```go: Go
import ( razorpay "github.com/razorpay/razorpay-go" )
client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

body, err := client.Invoice.Cancel("", nil, nil)

```csharp: .NET
RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

string invoiceId = "inv_DAweOiQ7amIUVd";

Invoice invoice = client.Invoice.Fetch(invoiceId).Cancel();

```json: Response
{
  "id": "inv_FHrZiAubEzDdaq",
  "entity": "invoice",
  "receipt": "Receipt No. 27",
  "invoice_number": "Receipt No. 27",
  "customer_id": "cust_BMB3EwbqnqZ2EI",
  "customer_details": {
    "id": "cust_BMB3EwbqnqZ2EI",
    "name": "Gaurav Kumar",
    "email": "gaurav.kumar@example.com",
    "contact": "9123456780",
    "gstin": null,
    "billing_address": null,
    "shipping_address": null,
    "customer_name": "Gaurav Kumar",
    "customer_email": "gaurav.kumar@example.com",
    "customer_contact": "9123456780"
  },
  "order_id": "order_FHrZiBOkWHZPOp",
  "line_items": [],
  "payment_id": null,
  "status": "cancelled",
  "expire_by": 1647483647,
  "issued_at": 1595491154,
  "paid_at": null,
  "cancelled_at": 1595491339,
  "expired_at": null,
  "sms_status": "sent",
  "email_status": "sent",
  "date": 1595491154,
  "terms": null,
  "partial_payment": false,
  "gross_amount": 0,
  "tax_amount": 0,
  "taxable_amount": 0,
  "amount": 0,
  "amount_paid": 0,
  "amount_due": 0,
  "currency": "INR",
  "currency_symbol": "₹",
  "description": "12 p.m. Meals",
  "notes": {
    "note_key 1": "Beam me up Scotty",
    "note_key 2": "Tea. Earl Gray. Hot."
  },
  "comment": null,
  "short_url": "https://rzp.io/i/bzDYbNg",
  "view_less": true,
  "billing_start": null,
  "billing_end": null,
  "type": "link",
  "group_taxes_discounts": false,
  "created_at": 1595491154,
  "idempotency_key": null,
  "token": {
    "method": "nach",
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    },
    "recurring_status": null,
    "failure_reason": null,
    "currency": "INR",
    "max_amount": 50000,
    "auth_type": "physical",
    "expire_at": 1947483647,
    "nach": {
      "create_form": true,
      "form_reference1": "Recurring Payment for Gaurav Kumar",
      "form_reference2": "Method Paper NACH",
      "prefilled_form": "https://rzp.io/i/tSYd5aV",
      "upload_form_url": "https://rzp.io/i/bzDYbNg",
      "description": "12 p.m. Meals"
    },
    "bank_account": {
      "ifsc": "HDFC0001233",
      "bank_name": "HDFC Bank",
      "name": "Gaurav Kumar",
      "account_number": "11214311215411",
      "account_type": "savings",
      "beneficiary_email": "gaurav.kumar@example.com",
      "beneficiary_mobile": "9123456780"
    },
    "first_payment_amount": 0
  },
  "nach_form_url": "https://rzp.io/i/tSYd5aV"
}
````

<Warning>
  **Watch Out!**

  You can only cancel the registration link that is in the `issued` state.

  #### Path Parameter

  `id` *mandatory*
  : `string` The unique identifier for the invoice linked to the registration link that you want to cancel. For example, `inv_1Aa00000000001`.

  #### Response Parameters

  `id`
  : `string` The unique identifier of the invoice.

  `entity`
  : `string` The entity that has been created. Here, it is `invoice`.

  `receipt`
  : `string` A user-entered unique identifier of the invoice.

  `invoice_number`
  : `string` Unique number you added for internal reference.

  `customer_id`
  : `string` The unique identifier of the customer. For example, `cust_BMB3EwbqnqZ2EI`.

  `customer_details`
  : `object` Details of the customer.

  `id`
  : `string` The unique identifier associated with the customer to whom the invoice has been issued.

  `name`
  : `string` The customer's name.

  `email`
  : `string` The customer's email address.

  `contact`
  : `integer` The customer's phone number.

  `billing_address`
  : `string` Details of the customer's billing address.

  `shipping_address`
  : `string` Details of the customer's shipping address.

  `order_id`
  : `string` The unique identifier of the order associated with the invoice.

  `line_items`
  : `string` Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.

  `payment_id`
  : `string` Unique identifier of a payment made against the invoice.

  `status`
  : `string` The status of the invoice. Possible values:

  * `draft`
  * `issued`
  * `partially_paid`
  * `paid`
  * `cancelled`
  * `expired`
  * `deleted`

  `expire_by`
  : `integer` The Unix timestamp at which the invoice will expire.

  `issued_at`
  : `integer` The Unix timestamp at which the invoice was issued to the customer.

  `paid_at`
  : `integer` The Unix timestamp at which the payment was made.

  `cancelled_at`
  : `integer` The Unix timestamp at which the invoice was cancelled.

  `expired_at`
  : `integer` The Unix timestamp at which the invoice expired.

  `sms_status`
  : `string` The delivery status of the SMS notification for the invoice sent to the customer. Possible values:

  * `pending`
  * `sent`

  `email_status`
  : `string` The delivery status of the email notification for the invoice sent to the customer. Possible values:

  * `pending`
  * `sent`

  `date`
  : `integer` Timestamp, in Unix format, that indicates the issue date of the invoice.

  `terms`
  : `string` Any terms to be included in the invoice. Maximum of 2048 characters.

  `partial_payment`
  : `boolean` Indicates whether the customer can make a partial payment on the invoice. Possible values:

  * `true`:  The customer can make partial payments.
  * `false` (default): The customer cannot make partial payments.

  `amount`
  : `integer` Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is 299.95, pass the value as `29995`.

  `amount_paid`
  : `integer` Amount paid by the customer against the invoice.

  `amount_due`
  : `integer` The remaining amount to be paid by the customer for the issued invoice.

  `currency`
  : `string` The currency associated with the invoice.

  `description`
  : `string`  A brief description of the invoice.

  `notes`
  : `object` Any custom notes added to the invoice. Maximum of 2048 characters.

  `short_url`
  : `string` The short URL that is generated. This is the link that can be shared with the customer to receive payments.

  `type`
  : `string` Here, it is `invoice`.

  `comment`
  : `string` Any comments to be added in the invoice. Maximum of 2048 characters.
</Warning>
